Index: other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/COMPILE.bash
===================================================================
--- other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/COMPILE.bash	(revision 31211)
+++ other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/COMPILE.bash	(revision 31212)
@@ -5,4 +5,6 @@
 
 # For running on Spark cluster:
-mvn assembly:assembly -DdescriptorId=jar-with-dependencies
+#mvn assembly:assembly -DdescriptorId=jar-with-dependencies
 
+mvn package
+
Index: other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/pom.xml
===================================================================
--- other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/pom.xml	(revision 31211)
+++ other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/pom.xml	(revision 31212)
@@ -57,14 +57,94 @@
    <build>
      <plugins>
-            <plugin>
-                <groupId>org.apache.maven.plugins</groupId>
-                <artifactId>maven-compiler-plugin</artifactId>
-                <version>2.3.2</version>
-                <configuration>
-                    <source>1.7</source>
-                    <target>1.7</target>
-                </configuration>
-            </plugin>
-	    
+       <plugin>
+	 <groupId>org.apache.maven.plugins</groupId>
+	 <artifactId>maven-compiler-plugin</artifactId>
+	 <version>2.3.2</version>
+	 <configuration>
+	   <source>1.8</source>
+	   <target>1.8</target>
+	 </configuration>
+       </plugin>
+
+       <plugin>
+	 <groupId>org.apache.maven.plugins</groupId>
+	 <artifactId>maven-shade-plugin</artifactId>
+	 <version>2.4.3</version>
+	 <configuration>
+	   <relocations>
+	     <relocation>
+	       <pattern>com.google.common</pattern>
+	       <shadedPattern>org.hathitrust.google.common</shadedPattern>
+	     </relocation>
+	   </relocations>
+	 </configuration>
+	 <executions>
+	   <execution>
+	     <phase>package</phase>
+	     <goals>
+	       <goal>shade</goal>
+	     </goals>
+
+	 <configuration>
+	   <archive>
+	     <manifest>
+               <mainClass>org.hathitrust.extractedfeatures.ProcessForSolrIngest</mainClass>
+	     </manifest>
+	   </archive>
+	   <filters>
+	     <filter>
+	       <artifact>*:*</artifact>
+	       <excludes>
+		 <exclude>META-INF/*.SF</exclude>
+		 <exclude>META-INF/*.DSA</exclude>
+		 <exclude>META-INF/*.RSA</exclude>
+	       </excludes>
+	     </filter>
+	   </filters>
+
+	   <finalName>${project.artifactId}-${project.version}-jar-with-dependencies</finalName>
+
+	 </configuration>
+
+	   </execution>
+	 </executions>
+
+<!--
+	 <executions>
+	   <execution>
+	     <phase>package</phase>
+	     <goals>
+	       <goal>shade</goal>
+	     </goals>
+	     <configuration>
+	       <filters>
+		 <filter>
+		   <artifact>*:*</artifact>
+		   <excludes>
+		     <exclude>META-INF/*.SF</exclude>
+		     <exclude>META-INF/*.DSA</exclude>
+		     <exclude>META-INF/*.RSA</exclude>
+		   </excludes>
+		 </filter>
+	       </filters>
+	       <artifactSet>
+		 <excludes>
+		   <exclude>org.datanucleus</exclude>
+		 </excludes>
+	       </artifactSet>
+	       <promoteTransitiveDependencies>true</promoteTransitiveDependencies>
+	       <transformers>
+		 <transformer
+		     implementation="org.apache.maven.plugins.shade.resource.ServicesResourceTransformer"
+		     />
+	       </transformers>
+	     </configuration>
+	   </execution>
+	 </executions>
+-->
+       </plugin>
+
+
+<!--	    
        <plugin>
 	 <groupId>org.apache.maven.plugins</groupId>
@@ -76,6 +156,18 @@
 	     </manifest>
 	   </archive>
+	   <filters>
+	     <filter>
+	       <artifact>*:*</artifact>
+	       <excludes>
+		 <exclude>META-INF/*.SF</exclude>
+		 <exclude>META-INF/*.DSA</exclude>
+		 <exclude>META-INF/*.RSA</exclude>
+	       </excludes>
+	     </filter>
+	   </filters>
+	   <finalName>uber-${project.artifactId}-${project.version}</finalName>
 	 </configuration>
        </plugin>
+-->
      </plugins>
    </build>