Index: other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/src/main/java/org/hathitrust/extractedfeatures/WhitelistBloomFilter.java
===================================================================
--- other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/src/main/java/org/hathitrust/extractedfeatures/WhitelistBloomFilter.java	(revision 31211)
+++ other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/src/main/java/org/hathitrust/extractedfeatures/WhitelistBloomFilter.java	(revision 31215)
@@ -3,6 +3,4 @@
 import java.io.BufferedInputStream;
 import java.io.BufferedOutputStream;
-import java.io.DataInputStream;
-import java.io.DataOutputStream;
 import java.io.File;
 import java.io.FileInputStream;
@@ -11,5 +9,4 @@
 import java.io.IOException;
 import java.io.InputStream;
-import java.io.OutputStream;
 import java.io.Serializable;
 import java.nio.charset.Charset;
@@ -21,15 +18,9 @@
 import javax.annotation.Nullable;
 
-import static com.google.common.base.Preconditions.checkNotNull;
-
 import com.google.common.base.Preconditions;
 import com.google.common.hash.BloomFilter;
-//import com.google.common.hash.BloomFilterAdvanced;
-//import com.google.common.hash.BloomFilterStrategies.BitArray;
 import com.google.common.hash.Funnel;
 import com.google.common.hash.Funnels;
 import com.google.common.hash.PrimitiveSink;
-import com.google.common.primitives.SignedBytes;
-import com.google.common.primitives.UnsignedBytes;
 
 public class WhitelistBloomFilter {
@@ -83,6 +74,5 @@
 				num_lines = countLines(dictionary_filename);
 				 
-				//Funnel<CharSequence> string_funnel = Funnels.stringFunnel(StandardCharsets.UTF_8);
-				Funnel<CharSequence> string_funnel = stringFunnel(StandardCharsets.UTF_8);
+				Funnel<CharSequence> string_funnel = Funnels.stringFunnel(StandardCharsets.UTF_8);
 				_bloomFilter = BloomFilter.create(string_funnel, num_lines,FALSE_POSITIVE_PERCENTAGE);
 			} 
@@ -154,6 +144,5 @@
 			BufferedInputStream bfis = new BufferedInputStream(fis);
 
-			//Funnel<CharSequence> string_funnel = Funnels.stringFunnel(StandardCharsets.UTF_8);
-			Funnel<CharSequence> string_funnel = stringFunnel(StandardCharsets.UTF_8);
+			Funnel<CharSequence> string_funnel = Funnels.stringFunnel(StandardCharsets.UTF_8);
 			bloomFilter = BloomFilter.readFrom(bfis,string_funnel);
 
@@ -171,66 +160,5 @@
 
 
-	// Spark uses Guava 14.0, the following is future-ported from Guava 20.0
-    // Added in here, rather then Funnel, and StringCharsetFunnel -> MyStringCharsetFunnel
-	
-	public static Funnel<CharSequence> stringFunnel(Charset charset) {
 
-	    return new MyStringCharsetFunnel(charset);
-
-	  }
-	
-	private static class MyStringCharsetFunnel implements Funnel<CharSequence>, Serializable {
-
-		private static final long serialVersionUID = 1L;
-		
-		private final Charset charset;
-
-	    MyStringCharsetFunnel(Charset charset) {
-	      this.charset = Preconditions.checkNotNull(charset);
-	    }
-
-	    public void funnel(CharSequence from, PrimitiveSink into) {
-	      into.putString(from, charset);
-	    }
-
-	    @Override
-	    public String toString() {
-	      return "Funnels.stringFunnel(" + charset.name() + ")";
-	    }
-
-	    @Override
-	    public boolean equals(@Nullable Object o) {
-
-	      if (o instanceof MyStringCharsetFunnel) {
-	        MyStringCharsetFunnel funnel = (MyStringCharsetFunnel) o;
-	        return this.charset.equals(funnel.charset);
-	      }
-	      return false;
-	    }
-
-	    @Override
-	    public int hashCode() {
-	      return MyStringCharsetFunnel.class.hashCode() ^ charset.hashCode();
-	    }
-
-	    Object writeReplace() {
-	      return new SerializedForm(charset);
-	    }
-
-	    private static class SerializedForm implements Serializable {
-	      private final String charsetCanonicalName;
-
-	      SerializedForm(Charset charset) {
-	        this.charsetCanonicalName = charset.name();
-	      }
-
-	      private Object readResolve() {
-	        return stringFunnel(Charset.forName(charsetCanonicalName));
-	      }
-
-	      private static final long serialVersionUID = 0;
-
-	    }
-	  }
 	
 	